#include "qe3.h"

//FIXME:  All of this should be converted over to use the new dir_t struct
int	numcategories, numlines, numtextures;

void AddTexture(char *name, char *from, category_t *currentcategory)
{
	categorytextures_t	*texture = malloc(sizeof(categorytextures_t));
//	Sys_Printf("Adding texture %s from %s.wad\n", name, from);

	texture->name = strdup(name);
	texture->from = strdup(from);
	texture->next = currentcategory->textures;
	currentcategory->textures = texture;
	numtextures++;
}

category_t *NewCategory(char *categoryname, category_t **currentcategory)
{
	category_t	*newcategory;

//	Sys_Printf("Adding category: %s\n", categoryname);
	newcategory = malloc(sizeof(category_t));
	newcategory->name = strdup(categoryname);
	newcategory->textures = NULL;
	newcategory->subcategories = NULL;
	newcategory->next = *currentcategory;
	*currentcategory = newcategory;
	numcategories++;
	return newcategory;
}

int ParseTexture(char *texturename, FILE *file, category_t *currentcategory)
{
	char				buf[512], *prefix, *value;
	char				*s, *temp;
	categorytextures_t	*newtexture;

	newtexture = malloc(sizeof(categorytextures_t));
	newtexture->name = strdup(texturename);
	newtexture->from = NULL;
	newtexture->next = currentcategory->textures;
	currentcategory->textures = newtexture;

//	Sys_Printf("Parsing texture: %s\n", texturename);

	while(!feof(file))
	{
		fgets(buf, 511, file);
		numlines++;
		s = buf;
//		Sys_Printf("%s", s);

		while(*s && (*s == ' '|| *s == '\t')) // Strip off leading whitespace
			s++;

		if(temp = strstr(s, "\n")) // Strip off newline
			*temp = 0;

		if(*s == '{' && *(s+1) == 0)
			continue; // ignore this line

		if(*s == '}' && *(s+1) == 0) // end of block
		{
			if(newtexture->from || globals.gametype == QUAKE2 || globals.gametype == SOF)
				return true;
			else
				return false;
		}

		prefix = get_token(&s, " \t=");
		value = get_token(&s, " \t\"");
//		Sys_Printf("Got %s : %s\n", prefix, value);

		if(prefix[0] && !prefix[1])
		{
			switch(prefix[0])
			{
				case 's':
					break; //do nothing with source directory

				case 'd':
					newtexture->from = strdup(value);
					break;

				case 'h':
					break;	//what is this anyway? value is always "C"
				case 'w':
					break;
			}
		}
		else
			break;
	}
	return false;
}

int ParseFolder(char *foldername, FILE *file, category_t **currentcategory)
{
	char		buf[512];
	char		*s, *temp;

	if(*currentcategory == categories)
		*currentcategory = NewCategory(foldername, &categories);
	else
		*currentcategory = NewCategory(foldername, currentcategory);

	while(!feof(file))
	{
		fgets(buf, 511, file);
		numlines++;
		s = buf;
//		Sys_Printf("%s", s);

		while(*s && (*s == ' '|| *s == '\t')) // Strip leading whitespace
			s++;
		if(temp = strstr(s, "\n")) // Strip off newline
			*temp = 0;

		if(temp = strstr(s, ".qtxfolder"))
		{
			*temp = 0;
			if(!ParseFolder(s, file, &(*currentcategory)->subcategories))
			{
				Sys_Printf("Error parsing folder: %s\n", s);
				break;
			}
			continue;
		}

		if(temp = strstr(s, ".txlist"))
		{
			*temp = 0;
			if(!ParseFolder(s, file, &(*currentcategory)->subcategories))
			{
				Sys_Printf("Error parsing texlist: %s\n", s);
				break;
			}
			continue;
		}

		if(temp = strstr(s, ".wl"))
		{
			*temp = 0;
			if(!ParseTexture(s, file, *currentcategory))
			{
				Sys_Printf("Error parsing texture: %s\n", s);
				break;
			}
			continue;
		}

		if(*s == '}' && !*(s+1))
			return true;
	}
	return false;
}

int currentmenuid;

void ParseTextureCategoryFile(void)
{
	FILE		*file;
	char		buf[512];
	char		*s, *temp;
	category_t	*currentcategory = categories;
	
	numcategories = numlines = numtextures = 0;

	if((file = fopen("scripts/textures.qe4", "r")) == NULL)
	{
		Sys_Printf("Could not open texture category file: scripts/textures.qe4\n");
		return;
	}

	while(!feof(file))
	{
		fgets(buf, 511, file);
		numlines++;
		s = buf;

//		Sys_Printf("%s", s);
		while(*s && (*s == ' '|| *s == '\t')) // Strip leading whitespace
			s++;
		if(temp = strstr(s, "\n")) // Strip off newline
			*temp = 0;

		if(!strncmp(s, "QQRKSRC1", 8))
			continue;

		if(temp = strstr(s, ".qtxfolder"))
		{
			*temp = 0;
			if(!ParseFolder(s, file, &currentcategory))
			{
				Sys_Printf("Error parsing texture category file\n");
				return;
			}
		}
	}
	currentmenuid = CMD_TEXTURECATEGORY;
	CreateCategoryMenus(GetSubMenu (GetMenu(globals.d_hwndMain), MENU_TEXTURE), categories, 8);
}

void CreateCategoryMenus(HMENU menu, category_t *category, int menupos)
{
	category_t	*currentcategory;
	HMENU		thismenu;
	
	for(currentcategory = category; currentcategory; currentcategory = currentcategory->next)
	{
		if(currentcategory->subcategories)
		{
			currentcategory->identifier = menupos;
			thismenu = CreatePopupMenu();
			InsertMenu(menu, menupos++, MF_BYPOSITION|MF_POPUP|MF_STRING, (unsigned int)thismenu, currentcategory->name);
			CreateCategoryMenus(thismenu, currentcategory->subcategories,0);
		}
		else
		{
			currentcategory->identifier = currentmenuid;
			InsertMenu(menu, menupos++, MF_BYPOSITION|MF_STRING, currentmenuid++, currentcategory->name);
		}

	}
}

category_t *FindCategory(int menunum, category_t *listhead)
{
	category_t	*category;
	category_t	*found;

	for (category = listhead; category; category = category->next)
	{
		if(category->subcategories)
		{
			found = FindCategory(menunum, category->subcategories);
			if(found)
				return found;
		}
		else
			if(category->identifier == menunum)
				return category;
	}
	return NULL;
}

