/*
===========================================================
New directory structure:

each level will consist of a run of "files", then a run of "subdirs"
===========================================================
*/
typedef struct file_s file_t;
typedef struct file_s
{
	char	*name;
	FILE	*file;
	int		offset;
	int		size;
	file_t	*next;
};

typedef struct dir_s dir_t;
struct dir_s
{
	char	*name;
	file_t	*files;
	dir_t	*subdirs;
	dir_t	*next;
	dir_t	*parent;
};

typedef struct qfile_s qfile_t;
struct qfile_s
{
	FILE	*diskfile;
	file_t	*pakfile;
	char	*flags;
};

#define TYPE_DIR	1
#define TYPE_DISK	2

extern dir_t *directories;

void	DirectoryInit		(void);
file_t	*AddFile			(dir_t *head, char *name, FILE *file, int offset, int size);
int		qLoadFile			(char *filename, void **bufferptr);
int		qLoadTextureFile	(char *filename, void **bufferptr);
qfile_t	*qfopen				(char *name, char *flags, char *ext);
int		qfseek				(qfile_t *file, int offset, int whence);
int		qftell				(qfile_t *file);
void	qfclose				(qfile_t *file);
size_t	qfread				(void *ptr, size_t size, size_t nmemb, qfile_t *file);
void	ClearDirectory		(dir_t **dirhead);
void	GetDirectories		(dir_t **dir);
dir_t	*FindDir			(dir_t *dir, char *name);
