// map.h -- the state of the current world that all views are displaying

typedef struct FACESEL_T
{
	face_t				*face;
	brush_t				*owner;
	float				trans;
	vec_t				dist;
	struct FACESEL_T	*next;
} facesel_t;

extern	char		currentmap[1024];

// head/tail of doubly linked lists
extern	brush_t			active_brushes;		/* brushes currently being
										   displayed */
extern	brush_t			selected_brushes;	// highlighted

extern	brush_t			clipper_brushes_front;
extern	brush_t			clipper_brushes_back;

//extern	face_t		*selected_face;
//extern	brush_t		*selected_face_brush;
extern	facesel_t		*selected_faces;
extern	facesel_t		*trans_faces;			// Faces to be drawn with transparency
extern	facesel_t		*trans_faces_rscript;	// Rscript faces to be drawn with transparency
extern	brush_t			filtered_brushes;		// brushes that have been filtered or regioned

extern	entity_t	entities;
extern	entity_t	*world_entity;		/* the world entity is NOT
										   included in the entities
										   chain */
extern	char		map_skyname[64];

extern	qboolean	modified;			// for quit confirmations

extern	vec3_t		region_mins, region_maxs;
extern	qboolean	region_active;

void 	Map_LoadFile				(char *filename);
void 	Map_SaveFile				(char *filename, qboolean use_region);
void	Map_New						(void);
void	Map_BuildBrushData			(void);

void	Map_RegionOff				(void);
void	Map_RegionXY				(void);
void	Map_RegionXZ				(void);
void	Map_RegionYZ				(void);
void	Map_RegionTallBrush			(void);
void	Map_RegionBrush				(void);
void	Map_RegionSelectedBrushes	(void);
void	Map_RegionSwap				(void);
void	Map_RegionVisGroup			(void);
qboolean Map_IsBrushFiltered		(brush_t *b);
