
typedef enum
{
	sel_brush,
	// sel_sticky_brush,
	// sel_face,
	sel_vertex,
	sel_edge
} select_t;

typedef struct
{
	brush_t		*brush;
	face_t		*face;
	float		dist;
	qboolean	selected;
} trace_t;

#define	SF_SELECTED_ONLY	1
#define	SF_ENTITIES_FIRST	2
#define	SF_SINGLEFACE		4

void ClearSelectedFaces				(facesel_t **);
void SelectFace						(facesel_t **, face_t *, brush_t *, float);
void Select_GetBounds				(vec3_t, vec3_t, brush_t *);
void Select_Brush					(brush_t *, int);
void Select_Delete					(void);
void Select_Deselect				(BOOL);
void Select_Clone					(void);
void Select_Move					(vec3_t);
void Select_SetTexture				(texdef_t *);
void Select_FlipAxis				(int);
void Select_RotateAxis				(int, float);
void Select_CompleteTall			(void);
void Select_PartialTall				(void);
void Select_Touching				(void);
void Select_Inside					(void);
void Select_MakeLight				(int, BOOL);
void Select_SetContentsFlag			(int);
void Select_UnsetContentsFlag		(int);
void Select_MakeLight				(int, BOOL);
void Select_SetSurfaceFlag			(int);
void Select_UnsetSurfaceFlag		(int);
void SelectContainingTexture		(BOOL, texdef_t *);
void SelectContainingFlag			(BOOL, BOOL, int);
void SelectFacesOfSelectedBrushes	(void);
void SelectBrushesWithSelectedFaces	(void);
void Select_FindBadBrushes			(void);
void Select_EntitiesByKeyVal		(char *, char *);
void Select_AllBrushes				(void);
void Select_AllFaces				(void);
void Select_InvertSelection			(void);

