#include "qe3.h"
#include "textures.h"
/*
=================
Texture_LoadMip
	Loads Quake 1 and Half-Life mipmaps
=================
*/
qtexture_t *Texture_LoadMip (miptex_t1 *qtex, char *name)
{
    byte		*source;
    int			width, height;
	GLuint		textures[2];
    qtexture_t	*q;
	char		*temp;
    
    width = LittleLong(qtex->width);
    height = LittleLong(qtex->height);

	if(!CheckTextureSize(width, height, qtex->name))
		return NULL;

	q = qmalloc(sizeof(*q));
	q->image = FindImage(name);

	q->flags = 0;
	q->value = 0;
	q->contents = 0;

	if(globals.gametype == HALFLIFE)
	{
		if(!stricmp(qtex->name, "sky"))
			q->flags |= SURF_SKY|SURF_NODRAW;

		if(!stricmp(qtex->name, "hint"))
			q->flags |= 0x100|SURF_NODRAW;

		if(!stricmp(qtex->name, "clip"))
		{
			q->flags |= SURF_NODRAW;
			q->contents |= (CONTENTS_PLAYERCLIP | CONTENTS_MONSTERCLIP);
		}

		if(!stricmp(qtex->name, "aaatrigger"))
			q->flags |= SURF_NODRAW;		
	}
	else
	{
		if(!strnicmp(qtex->name, "sky", 3))
			q->flags |= SURF_SKY|SURF_NODRAW;
		
		if(!stricmp(qtex->name, "trigger"))
			q->flags |= SURF_NODRAW;		
	}
	


	if(qtex->name[0] == '+' || qtex->name[0] == '*')
	{
		temp = &(qtex->name[1]);
		if(!strnicmp(temp, "water", 5) || !strnicmp(temp, "slime", 5))
			q->flags |= SURF_TRANS33;
	}

	if(!q->image)
		q->image = NewImage(name, false);

    q->image->width = width;
    q->image->height = height;
    source = (byte *)qtex + LittleLong(qtex->offset1);
	glGenTextures (1, textures);
	q->image->texture_number = textures[0];
	
	GL_Upload(width, height, source, q->image, 1);

    return q;
}
