typedef struct visgroup_s
{
	char				*name;
	vec3_t				color;
	int					identifier; // Only used during map loads
	struct visgroup_s	*next;
	struct visgroup_s	*prev;
}visgroup_t;

extern visgroup_t	visgroups;
extern visgroup_t	*currentvisgroup;

void		VisGroup_AddToList		(visgroup_t *g);
void		VisGroup_RemoveFromList	(visgroup_t *g);
void		VisGroups_Init			(void);
int			VisGroup_AddNew			(char *name, vec3_t color, int identifier);
int			VisGroup_Renumber		(void);
void		VisGroup_SetName		(visgroup_t *g, char *newname);
visgroup_t	*GetVisGroup			(int identifier);
void		ParseVisGroup			(char **line);
void		ReplaceVisGroup			(visgroup_t *old, visgroup_t *newgroup);
void		VisGroup_Free			(visgroup_t *g);
void		VisGroup_FillListBox	(HWND h);
void		VisGroup_SetSelected	(void);
void		Visgroup_WriteHeader	(FILE *f);
void		VisGroup_ClearAll		(void);
