
#include "qe3.h"
#include "inc.h"

void Refresh_Textures(void);
void Texture_InitPalette (byte *pal);

int		m_nHeight, m_nWidth;
BOOL SurfaceDlgActive;
globals_t gcopy;
NMHDR	*hdr;
m_nWidth = 1;
m_nHeight = 1;

LRESULT (CALLBACK* OldHShiftEditWindowProc) (HWND, UINT, WPARAM, LPARAM);
LRESULT (CALLBACK* OldHScaleEditWindowProc) (HWND, UINT, WPARAM, LPARAM);
LRESULT (CALLBACK* OldVShiftEditWindowProc) (HWND, UINT, WPARAM, LPARAM);
LRESULT (CALLBACK* OldVScaleEditWindowProc) (HWND, UINT, WPARAM, LPARAM);
LRESULT (CALLBACK* OldRotateEditWindowProc) (HWND, UINT, WPARAM, LPARAM);

BOOL CALLBACK GammaDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	char	sz[256];
	HWND	h;

	switch (uMsg)
    {
	case WM_INITDIALOG:
		sprintf(sz, "%1.1f", gcopy.d_savedinfo.fGamma);
		SetWindowText(GetDlgItem(hwndDlg, IDC_G_EDIT), sz);
		h = GetDlgItem(hwndDlg, IDC_G_EDIT);
		SetFocus (h);
		return TRUE;

	case WM_NOTIFY:
		hdr = (NMHDR *)lParam;

		switch (hdr->code)
		{
			case PSN_KILLACTIVE:
			case PSN_APPLY:
				GetWindowText(GetDlgItem(hwndDlg, IDC_G_EDIT), sz, 255);
				
				if(gcopy.d_savedinfo.fGamma != atof(sz))
					gcopy.d_savedinfo.fGamma = atof(sz);
				
				return FALSE;
				break;
		}
		break;
	}
	return FALSE;
}


//================================================


void SelectBrush (int entitynum, int brushnum)
{
	entity_t	*e;
	brush_t		*b;
	int			i;

	if (entitynum == 0)
		e = world_entity;
	else
	{
		e = entities.next;
		while (--entitynum)
		{
			e=e->next;
			if (e == &entities)
			{
				Sys_Status(0, "No such entity.");
				return;
			}
		}
	}

	b = e->brushes.onext;
	if (b == &e->brushes)
	{
		Sys_Status(0, "No such brush.");
		return;
	}
	while (brushnum--)
	{
		b=b->onext;
		if (b == &e->brushes)
		{
			Sys_Status(0, "No such brush.");
			return;
		}
	}

	Brush_RemoveFromList (b);
	Brush_AddToList (b, &selected_brushes);


	Sys_UpdateWindows (W_CAMERA | W_XY | W_XZ | W_YZ | W_Z);
	for (i=0 ; i<3 ; i++)
	{
		globals.XY.origin[i] = globals.XZ.origin[i] = globals.YZ.origin[i] = (b->mins[i] + b->maxs[i])/2;
	}

	Sys_Status(0, "Selected.");
}

/*
=================
GetSelectionIndex
=================
*/
void GetSelectionIndex (int *ent, int *brush)
{
	brush_t		*b, *b2;
	entity_t	*entity;

	*ent = *brush = 0;

	b = selected_brushes.next;
	if (b == &selected_brushes)
		return;

	// find entity
	if (b->owner != world_entity)
	{
		(*ent)++;
		for (entity = entities.next ; entity != &entities 
			; entity=entity->next, (*ent)++)
		;
	}

	// find brush
	for (b2=b->owner->brushes.onext 
		; b2 != b && b2 != &b->owner->brushes
		; b2=b2->onext, (*brush)++)
	;
}

BOOL CALLBACK FindBrushDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	char entstr[256];
	char brushstr[256];
	HWND	h;
	int		ent, brush;

	switch (uMsg)
    {
	case WM_INITDIALOG:
		// set entity and brush number
		GetSelectionIndex (&ent, &brush);
		sprintf (entstr, "%i", ent);
		sprintf (brushstr, "%i", brush);
		SetWindowText(GetDlgItem(hwndDlg, IDC_FIND_ENTITY), entstr);
		SetWindowText(GetDlgItem(hwndDlg, IDC_FIND_BRUSH), brushstr);

		h = GetDlgItem(hwndDlg, IDC_FIND_ENTITY);
		SetFocus (h);
		return FALSE;

	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{ 
			case IDOK:
				GetWindowText(GetDlgItem(hwndDlg, IDC_FIND_ENTITY), entstr, 255);
				GetWindowText(GetDlgItem(hwndDlg, IDC_FIND_BRUSH), brushstr, 255);
				SelectBrush (atoi(entstr), atoi(brushstr));
				EndDialog(hwndDlg, 1);
				return TRUE;

			case IDCANCEL:
				EndDialog(hwndDlg, 0);
				return TRUE;
		}	
	}
	return FALSE;
}



void DoFind(void)
{
	DialogBox(globals.d_hInstance, (char *)IDD_FINDBRUSH, globals.d_hwndMain, FindBrushDlgProc);
}	
	
/*
===================================================

  ARBITRARY ROTATE

===================================================
*/


BOOL CALLBACK RotateDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	char	str[256];
	HWND	h;
	float	v;

	switch (uMsg)
    {
	case WM_INITDIALOG:
		h = GetDlgItem(hwndDlg, IDC_ROTX);
		SetFocus (h);
		return FALSE;

	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{ 
		
		case IDOK:
			GetWindowText(GetDlgItem(hwndDlg, IDC_ROTX), str, 255);
			v = atof(str);
			if (v)
				Select_RotateAxis (0, v);

			GetWindowText(GetDlgItem(hwndDlg, IDC_ROTY), str, 255);
			v = atof(str);
			if (v)
				Select_RotateAxis (1, v);

			GetWindowText(GetDlgItem(hwndDlg, IDC_ROTZ), str, 255);
			v = atof(str);
			if (v)
				Select_RotateAxis (2, v);

			EndDialog(hwndDlg, 1);
			return TRUE;

		case IDCANCEL:
			EndDialog(hwndDlg, 0);
			return TRUE;
		}	
	}

	return FALSE;
}



void DoRotate(void)
{
	DialogBox(globals.d_hInstance, (char *)IDD_ROTATE, globals.d_hwndMain, RotateDlgProc);
}
		
/*
===================================================

  ARBITRARY SIDES

===================================================
*/


BOOL CALLBACK SidesDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	char str[256];
	HWND	h;

	switch (uMsg)
    {
	case WM_INITDIALOG:
		h = GetDlgItem(hwndDlg, IDC_SIDES);
		SetFocus (h);
		return FALSE;

	case WM_COMMAND: 
		switch (LOWORD(wParam)) { 
		
		case IDOK:
			GetWindowText(GetDlgItem(hwndDlg, IDC_SIDES), str, 255);
			Brush_MakeSided (atoi(str));

			EndDialog(hwndDlg, 1);
		break;

		case IDCANCEL:
			EndDialog(hwndDlg, 0);
		break;
	}	
	default:
		return FALSE;
	}
}



void DoSides(void)
{
	DialogBox(globals.d_hInstance, (char *)IDD_SIDES, globals.d_hwndMain, SidesDlgProc);
}		

//======================================================================

/*
===================
DoAbout
===================
*/
BOOL CALLBACK AboutDlgProc( HWND hwndDlg,
						    UINT uMsg,
						    WPARAM wParam,
						    LPARAM lParam )
{
	switch (uMsg)
    {
	case WM_INITDIALOG:
		{
			char renderer[1024];
			char version[1024];
			char vendor[1024];
			char extensions[4096];
			char extensions_copy[4096];
			char *s;

			sprintf( renderer, "Renderer:\t%s", glGetString( GL_RENDERER ) );
			sprintf( version, "Version:\t\t%s", glGetString( GL_VERSION ) );
			sprintf( vendor, "Vendor:\t\t%s", glGetString( GL_VENDOR ) );
			strcpy ( extensions, glGetString( GL_EXTENSIONS ));
			extensions_copy[0] = 0;

			for(s = strtok(extensions, " \n\t"); s; s = strtok(NULL, " \n"))
			{
				strcat(extensions_copy, s);
				strcat(extensions_copy, "\r\n");
			}

			SetWindowText( GetDlgItem( hwndDlg, IDC_ABOUT_GLRENDERER ),   renderer );
			SetWindowText( GetDlgItem( hwndDlg, IDC_ABOUT_GLVERSION ),    version );
			SetWindowText( GetDlgItem( hwndDlg, IDC_ABOUT_GLVENDOR ),     vendor );
			SetWindowText( GetDlgItem( hwndDlg, IDC_ABOUT_GLEXTENSIONS ), extensions_copy );
		}
		return TRUE;

	case WM_CLOSE:
		EndDialog( hwndDlg, 1 );
		return TRUE;

	case WM_COMMAND:
		if ( LOWORD( wParam ) == IDOK )
			EndDialog(hwndDlg, 1);
		return TRUE;
	}
	return FALSE;
}

void DoAbout(void)
{
	DialogBox( globals.d_hInstance, ( char * ) IDD_ABOUT, globals.d_hwndMain, AboutDlgProc );
}


/*
===================================================

  SURFACE INSPECTOR

===================================================
*/

texdef_t	g_old_texdef;
HWND		g_surfwin;
qboolean	g_changed_surface;
RECT		g_surfrect;
int			g_surfrectinitialised = false;

int	g_checkboxes[64] = { 
	IDC_CHECK1, IDC_CHECK2, IDC_CHECK3, IDC_CHECK4, 
	IDC_CHECK5, IDC_CHECK6, IDC_CHECK7, IDC_CHECK8, 
	IDC_CHECK9, IDC_CHECK10, IDC_CHECK11, IDC_CHECK12, 
	IDC_CHECK13, IDC_CHECK14, IDC_CHECK15, IDC_CHECK16,
	IDC_CHECK17, IDC_CHECK18, IDC_CHECK19, IDC_CHECK20,
	IDC_CHECK21, IDC_CHECK22, IDC_CHECK23, IDC_CHECK24,
	IDC_CHECK25, IDC_CHECK26, IDC_CHECK27, IDC_CHECK28,
	IDC_CHECK29, IDC_CHECK30, IDC_CHECK31, IDC_CHECK32,

	IDC_CHECK33, IDC_CHECK34, IDC_CHECK35, IDC_CHECK36,
	IDC_CHECK37, IDC_CHECK38, IDC_CHECK39, IDC_CHECK40,
	IDC_CHECK41, IDC_CHECK42, IDC_CHECK43, IDC_CHECK44,
	IDC_CHECK45, IDC_CHECK46, IDC_CHECK47, IDC_CHECK48,
	IDC_CHECK49, IDC_CHECK50, IDC_CHECK51, IDC_CHECK52,
	IDC_CHECK53, IDC_CHECK54, IDC_CHECK55, IDC_CHECK56,
	IDC_CHECK57, IDC_CHECK58, IDC_CHECK59, IDC_CHECK60,
	IDC_CHECK61, IDC_CHECK62, IDC_CHECK63, IDC_CHECK64
 };

/*
==============
SetTexMods

Set the fields to the current texdef
===============
*/
void SetTexMods(void)
{
	char		sz[128];
	texdef_t	*pt;
	int			i;
//	RECT		rect;

	pt = &globals.d_texturewin.texdef;

	SendMessage (g_surfwin, WM_SETREDRAW, 0, 0);

	SetWindowText(GetDlgItem(g_surfwin, IDC_TEXTURECOMBO), pt->name);
		
	sprintf(sz, "%d", (int)pt->shift[0]);
	SetWindowText(GetDlgItem(g_surfwin, IDC_HSHIFT), sz);

	sprintf(sz, "%d", (int)pt->shift[1]);
	SetWindowText(GetDlgItem(g_surfwin, IDC_VSHIFT), sz);

	sprintf(sz, "%4.2f", pt->scale[0]);
	SetWindowText(GetDlgItem(g_surfwin, IDC_HSCALE), sz);

	sprintf(sz, "%4.2f", pt->scale[1]);
	SetWindowText(GetDlgItem(g_surfwin, IDC_VSCALE), sz);

	sprintf(sz, "%d", (int)pt->rotate);
	SetWindowText(GetDlgItem(g_surfwin, IDC_ROTATE), sz);

	sprintf(sz, "%d", (int)m_nWidth);
	SetWindowText(GetDlgItem(g_surfwin, IDC_WIDTH_EDIT), sz);

	sprintf(sz, "%d", (int)m_nHeight);
	SetWindowText(GetDlgItem(g_surfwin, IDC_HEIGHT_EDIT), sz);

	if(g_surfrectinitialised)
	{
		SetWindowPos(g_surfwin, HWND_TOPMOST, g_surfrect.left, g_surfrect.top, g_surfrect.right-g_surfrect.left, g_surfrect.bottom-g_surfrect.top, SWP_SHOWWINDOW);
	}
	else
	{
		GetWindowRect(g_surfwin, &g_surfrect);
		g_surfrectinitialised = true;
	}

	if(globals.ShowFullSurfaceEditor)
	{
		SetWindowPos(g_surfwin, HWND_TOPMOST, g_surfrect.left, g_surfrect.top, 602, 319, SWP_SHOWWINDOW);
		EnableWindow(GetDlgItem(g_surfwin, IDC_VALUE), TRUE);
		EnableWindow(GetDlgItem(g_surfwin, IDC_VALUE_STATIC), TRUE);
		sprintf(sz, "%d", (int)pt->value);
		SetWindowText(GetDlgItem(g_surfwin, IDC_VALUE), sz);
		
		for (i=0 ; i<32 ; i++)
			SendMessage(GetDlgItem(g_surfwin, IDC_CHECK1+i), BM_SETCHECK, !!(pt->flags&(1<<i)), 0 );

		for (i=0 ; i<32 ; i++)
			SendMessage(GetDlgItem(g_surfwin, IDC_CHECK33+i), BM_SETCHECK, !!(pt->contents&(1<<i)), 0 );
		
		for(i = IDC_CHECK1; i <= IDC_CHECK32; i++)
			SetWindowText(GetDlgItem(g_surfwin, i), Surface_FlagNames[i-IDC_CHECK1]);
		
		for(i = IDC_CHECK33; i <= IDC_CHECK64; i++)
			SetWindowText(GetDlgItem(g_surfwin, i), Content_FlagNames[i-IDC_CHECK33]);
	}
	else
	{
		SetWindowPos(g_surfwin, HWND_TOPMOST, g_surfrect.left, g_surfrect.top, 227, 319, SWP_SHOWWINDOW);
		EnableWindow(GetDlgItem(g_surfwin, IDC_VALUE), FALSE);
		EnableWindow(GetDlgItem(g_surfwin, IDC_VALUE_STATIC), FALSE);
	}
		
//	SendMessage (g_surfwin, WM_SETREDRAW, 1, 0);
	InvalidateRect (g_surfwin, NULL, true);
	UpdateWindow(g_surfwin);
}


/*
==============
GetTexMods

Reads the fields to get the current texdef
===============
*/
void GetTexMods(void)
{
	char	sz[128];
	texdef_t *pt;
	int		b;
	int		i;

	pt = &globals.d_texturewin.texdef;

	GetWindowText (GetDlgItem(g_surfwin, IDC_TEXTURECOMBO), sz, 127);
	strncpy (pt->name, sz, sizeof(pt->name)-1);
	if (pt->name[0] <= ' ')
	{
		strcpy (pt->name, "none");
		SetWindowText(GetDlgItem(g_surfwin, IDC_TEXTURECOMBO), pt->name);
	}

	GetWindowText (GetDlgItem(g_surfwin, IDC_HSHIFT), sz, 127);
	pt->shift[0] = atof(sz);

	GetWindowText (GetDlgItem(g_surfwin, IDC_VSHIFT), sz, 127);
	pt->shift[1] = atof(sz);

	GetWindowText(GetDlgItem(g_surfwin, IDC_HSCALE), sz, 127);
	pt->scale[0] = atof(sz);

	GetWindowText(GetDlgItem(g_surfwin, IDC_VSCALE), sz, 127);
	pt->scale[1] = atof(sz);

	GetWindowText(GetDlgItem(g_surfwin, IDC_ROTATE), sz, 127);
	pt->rotate = atof(sz);

	GetWindowText(GetDlgItem(g_surfwin, IDC_VALUE), sz, 127);
	pt->value = atof(sz);

	pt->flags = 0;
	for (i=0 ; i<32 ; i++)
	{
		b = SendMessage(GetDlgItem(g_surfwin, g_checkboxes[i]), BM_GETCHECK, 0, 0);
		if (b != 1 && b != 0)
			continue;
		pt->flags |= b<<i;
	}

	pt->contents = 0;
	for (i=0 ; i<32 ; i++)
	{
		b = SendMessage(GetDlgItem(g_surfwin, g_checkboxes[32+i]), BM_GETCHECK, 0, 0);
		if (b != 1 && b != 0)
			continue;
		pt->contents |= b<<i;
	}

	g_changed_surface = true;
	Select_SetTexture(pt);
}

/*
=================
UpdateSpinners
=================
*/
void UpdateSpinners(unsigned uMsg, WPARAM wParam, LPARAM lParam)
{
	int nScrollCode;
	HWND hwnd;
	texdef_t *pt;

	pt = &globals.d_texturewin.texdef;

	nScrollCode = (int) LOWORD(wParam);  // scroll bar value 
	hwnd = (HWND) lParam;       // handle of scroll bar 

	if ((nScrollCode != SB_LINEUP) && (nScrollCode != SB_LINEDOWN))
		return;
	
	if (hwnd == GetDlgItem(g_surfwin, IDC_ROTATEA))
	{
		if (nScrollCode == SB_LINEUP)
			if(GetKeyState(VK_SHIFT) < 0)
				pt->rotate += 5;
			else if(GetKeyState(VK_CONTROL) < 0)
				pt->rotate += 1;
			else
				pt->rotate += 45;
		else
			if(GetKeyState(VK_SHIFT) < 0)
				pt->rotate -= 5;
			else if(GetKeyState(VK_CONTROL) < 0)
				pt->rotate -= 1;
			else
				pt->rotate -= 45;

		if (pt->rotate < 0)
			pt->rotate += 360;

		if (pt->rotate >= 360)
			pt->rotate -= 360;
	}

	else if (hwnd == GetDlgItem(g_surfwin, IDC_HSCALEA))
	{
		if (nScrollCode == SB_LINEDOWN)
			if(GetKeyState(VK_SHIFT) < 0)
				pt->scale[0] -= (float)0.1;
			else if(GetKeyState(VK_CONTROL) < 0)
				pt->scale[0] -= (float)0.01;
			else
				pt->scale[0] -= (float)0.5;
		else
			if(GetKeyState(VK_SHIFT) < 0)
				pt->scale[0] += (float)0.1;
			else if(GetKeyState(VK_CONTROL) < 0)
				pt->scale[0] += (float)0.01;
			else
				pt->scale[0] += (float)0.5;
	}
	
	else if (hwnd == GetDlgItem(g_surfwin, IDC_VSCALEA))
	{
		if (nScrollCode == SB_LINEUP)
			if(GetKeyState(VK_SHIFT) < 0)
				pt->scale[1] += (float)0.1;
			else if(GetKeyState(VK_CONTROL) < 0)
				pt->scale[1] += (float)0.01;
			else
				pt->scale[1] += (float)0.5;
		else
			if(GetKeyState(VK_SHIFT) < 0)
				pt->scale[1] -= (float)0.1;
			else if(GetKeyState(VK_CONTROL) < 0)
				pt->scale[1] -= (float)0.01;
			else
				pt->scale[1] -= (float)0.5;
	} 
	
	else if (hwnd == GetDlgItem(g_surfwin, IDC_HSHIFTA))
	{
		if (nScrollCode == SB_LINEDOWN)
			if(GetKeyState(VK_SHIFT) < 0)
				pt->shift[0] -= 32;
			else if(GetKeyState(VK_CONTROL) < 0)
				pt->shift[0] -= 1;
			else
				pt->shift[0] -= globals.d_gridsize;
		else
			if(GetKeyState(VK_SHIFT) < 0)
				pt->shift[0] += 32;
			else if(GetKeyState(VK_CONTROL) < 0)
				pt->shift[0] += 1;
			else
				pt->shift[0] += globals.d_gridsize;
	}
	
	else if (hwnd == GetDlgItem(g_surfwin, IDC_VSHIFTA))
	{
		if (nScrollCode == SB_LINEUP)
			if(GetKeyState(VK_SHIFT) < 0)
				pt->shift[1] += 32;
			else if(GetKeyState(VK_CONTROL) < 0)
				pt->shift[1] += 1;
			else
				pt->shift[1] += globals.d_gridsize;
		else
			if(GetKeyState(VK_SHIFT) < 0)
				pt->shift[1] -= 32;
			else if(GetKeyState(VK_CONTROL) < 0)
				pt->shift[1] -= 1;
			else
				pt->shift[1] -= globals.d_gridsize;
	}

	SetTexMods();
	g_changed_surface = true;
	Select_SetTexture(pt);
}

BOOL CALLBACK HShiftEditWndProc(
    HWND hwnd,
    UINT uMsg,
    WPARAM wParam,
    LPARAM lParam)
{
    switch (uMsg)
    {
	case WM_KEYDOWN:
		if (LOWORD(wParam) == VK_UP)
		{
			UpdateSpinners(uMsg, SB_LINEUP, (LPARAM)GetDlgItem(g_surfwin, IDC_HSHIFTA));
			return 0;
		}
		if (LOWORD(wParam) == VK_DOWN)
		{
			UpdateSpinners(uMsg, SB_LINEDOWN, (LPARAM)GetDlgItem(g_surfwin, IDC_HSHIFTA));
			return 0;
		}
		break;
	}
	return CallWindowProc (OldHShiftEditWindowProc, hwnd, uMsg, wParam, lParam);
}

BOOL CALLBACK HScaleEditWndProc(
    HWND hwnd,
    UINT uMsg,
    WPARAM wParam,
    LPARAM lParam)
{
    switch (uMsg)
    {
	case WM_KEYDOWN:
		if (LOWORD(wParam) == VK_UP)
		{
			UpdateSpinners(uMsg, SB_LINEUP, (LPARAM)GetDlgItem(g_surfwin, IDC_HSCALEA));
			return 0;
		}
		if (LOWORD(wParam) == VK_DOWN)
		{
			UpdateSpinners(uMsg, SB_LINEDOWN, (LPARAM)GetDlgItem(g_surfwin, IDC_HSCALEA));
			return 0;
		}
		break;
	}
	return CallWindowProc (OldHScaleEditWindowProc, hwnd, uMsg, wParam, lParam);
}

BOOL CALLBACK VShiftEditWndProc(
    HWND hwnd,
    UINT uMsg,
    WPARAM wParam,
    LPARAM lParam)
{
    switch (uMsg)
    {
	case WM_KEYDOWN:
		if (LOWORD(wParam) == VK_UP)
		{
			UpdateSpinners(uMsg, SB_LINEUP, (LPARAM)GetDlgItem(g_surfwin, IDC_VSHIFTA));
			return 0;
		}
		if (LOWORD(wParam) == VK_DOWN)
		{
			UpdateSpinners(uMsg, SB_LINEDOWN, (LPARAM)GetDlgItem(g_surfwin, IDC_VSHIFTA));
			return 0;
		}
		break;
	}
	return CallWindowProc (OldVShiftEditWindowProc, hwnd, uMsg, wParam, lParam);
}

BOOL CALLBACK VScaleEditWndProc(
    HWND hwnd,
    UINT uMsg,
    WPARAM wParam,
    LPARAM lParam)
{
    switch (uMsg)
    {
	case WM_KEYDOWN:
		if (LOWORD(wParam) == VK_UP)
		{
			UpdateSpinners(uMsg, SB_LINEUP, (LPARAM)GetDlgItem(g_surfwin, IDC_VSCALEA));
			return 0;
		}
		if (LOWORD(wParam) == VK_DOWN)
		{
			UpdateSpinners(uMsg, SB_LINEDOWN, (LPARAM)GetDlgItem(g_surfwin, IDC_VSCALEA));
			return 0;
		}
		break;
	}
	return CallWindowProc (OldVScaleEditWindowProc, hwnd, uMsg, wParam, lParam);
}

BOOL CALLBACK RotateEditWndProc(
    HWND hwnd,
    UINT uMsg,
    WPARAM wParam,
    LPARAM lParam)
{
    switch (uMsg)
    {
	case WM_KEYDOWN:
		if (LOWORD(wParam) == VK_UP)
		{
			UpdateSpinners(uMsg, SB_LINEUP, (LPARAM)GetDlgItem(g_surfwin, IDC_ROTATEA));
			return 0;
		}
		if (LOWORD(wParam) == VK_DOWN)
		{
			UpdateSpinners(uMsg, SB_LINEDOWN, (LPARAM)GetDlgItem(g_surfwin, IDC_ROTATEA));
			return 0;
		}
		break;
	}
	return CallWindowProc (OldRotateEditWindowProc, hwnd, uMsg, wParam, lParam);
}

void Select_FitTexture(int nHeight, int nWidth);

BOOL CALLBACK SurfaceDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	HWND			h;

	switch (uMsg)
    {
	case WM_INITDIALOG:
		SurfaceDlgActive = true;
		g_surfwin = hwndDlg;
		h = GetDlgItem(hwndDlg, IDC_TEXTURECOMBO);

		if(selected_brushes.prev != &selected_brushes)
		{
			globals.d_texturewin.texdef = selected_brushes.prev->brush_faces->texdef;
			InvalidateRect(globals.Camera.hwnd, NULL, false);
			UpdateWindow (globals.Camera.hwnd);
		}

		if(selected_faces)
		{
			face_t		*face;
			facesel_t	*f;

			for(f = selected_faces; f; f = f->next)
			{
				face = f->face;
			}

			globals.d_texturewin.texdef = face->texdef;
			InvalidateRect(globals.Camera.hwnd, NULL, false);
			UpdateWindow (globals.Camera.hwnd);
		}

		// save current state for cancel
		g_old_texdef = globals.d_texturewin.texdef;
		g_changed_surface = false;

		FillComboBoxWithTextures(h);
		SetTexMods ();
//		h = GetDlgItem(hwndDlg, IDC_TEXTURE);

		SetFocus (h);
		OldHShiftEditWindowProc = (void *)GetWindowLong (GetDlgItem(hwndDlg, IDC_HSHIFT), GWL_WNDPROC);
		SetWindowLong (GetDlgItem(hwndDlg, IDC_HSHIFT), GWL_WNDPROC, (long)HShiftEditWndProc);
		OldHScaleEditWindowProc = (void *)GetWindowLong (GetDlgItem(hwndDlg, IDC_HSCALE), GWL_WNDPROC);
		SetWindowLong (GetDlgItem(hwndDlg, IDC_HSCALE), GWL_WNDPROC, (long)HScaleEditWndProc);
		OldVShiftEditWindowProc = (void *)GetWindowLong (GetDlgItem(hwndDlg, IDC_VSHIFT), GWL_WNDPROC);
		SetWindowLong (GetDlgItem(hwndDlg, IDC_VSHIFT), GWL_WNDPROC, (long)VShiftEditWndProc);
		OldVScaleEditWindowProc = (void *)GetWindowLong (GetDlgItem(hwndDlg, IDC_VSCALE), GWL_WNDPROC);
		SetWindowLong (GetDlgItem(hwndDlg, IDC_VSCALE), GWL_WNDPROC, (long)VScaleEditWndProc);
		OldRotateEditWindowProc = (void *)GetWindowLong (GetDlgItem(hwndDlg, IDC_ROTATE), GWL_WNDPROC);
		SetWindowLong (GetDlgItem(hwndDlg, IDC_ROTATE), GWL_WNDPROC, (long)RotateEditWndProc);
		return FALSE;

	case WM_COMMAND: 
		switch (LOWORD(wParam))
		{
			case IDOK:
				GetTexMods ();
				EndDialog(hwndDlg, 1);
				break;
			
			case IDAPPLY:
				GetTexMods ();
				InvalidateRect(globals.Camera.hwnd, NULL, false);
				UpdateWindow (globals.Camera.hwnd);
				if(globals.d_xy.draw_mode == cd_texture)
				{
					InvalidateRect(globals.XY.hwnd, NULL, false);
					UpdateWindow (globals.XY.hwnd);
				}
				break;
			
			case IDCANCEL:
				globals.d_texturewin.texdef = g_old_texdef;
				if (g_changed_surface)
					Select_SetTexture(&globals.d_texturewin.texdef);
				EndDialog(hwndDlg, 0);
				break;
			case IDC_BUTTONFIT:
			{
				char	sz[128];
				
				GetWindowText (GetDlgItem(g_surfwin, IDC_WIDTH_EDIT), sz, 127);
				m_nWidth = atoi(sz);
				GetWindowText (GetDlgItem(g_surfwin, IDC_HEIGHT_EDIT), sz, 127);
				m_nHeight = atoi(sz);
				Select_FitTexture(m_nHeight, m_nWidth);
				InvalidateRect(globals.Camera.hwnd, NULL, false);
				UpdateWindow (globals.Camera.hwnd);
				if(globals.d_xy.draw_mode == cd_texture)
				{
					InvalidateRect(globals.XY.hwnd, NULL, false);
					UpdateWindow (globals.XY.hwnd);
					InvalidateRect(globals.XZ.hwnd, NULL, false);
					UpdateWindow (globals.XZ.hwnd);
					InvalidateRect(globals.YZ.hwnd, NULL, false);
					UpdateWindow (globals.YZ.hwnd);
				}
				g_changed_surface = true;
				SetTexMods();
			}
			break;
		}	
		break;

	case WM_HSCROLL:
	case WM_VSCROLL:
		UpdateSpinners(uMsg, wParam, lParam);
		InvalidateRect(globals.Camera.hwnd, NULL, false);
		UpdateWindow (globals.Camera.hwnd);
		if(globals.d_xy.draw_mode == cd_texture)
		{
			InvalidateRect(globals.XY.hwnd, NULL, false);
			UpdateWindow (globals.XY.hwnd);
		}
		return 0;

	case WM_KEYDOWN:
		if (LOWORD(wParam) == VK_ESCAPE)
		{
			globals.d_texturewin.texdef = g_old_texdef;
			if (g_changed_surface)
				Select_SetTexture(&globals.d_texturewin.texdef);
			EndDialog(hwndDlg, 0);
		}
		break;

	case WM_DESTROY:
		SurfaceDlgActive = false;
		InvalidateRect(NULL, &g_surfrect, false);	// Make sure anything under the surface dialog gets redrawn.
//		UpdateWindow (globals.d_hwndToolbar);
		break;

	case WM_MOVING:
		{
			RECT	*rect = (RECT *)lParam;

			g_surfrect.left = rect->left;
			g_surfrect.top = rect->top;
			g_surfrect.right = rect->right;
			g_surfrect.bottom = rect->bottom;
			break;
		}
	}
	return FALSE;
}


void DoSurface (void)
{
	if(SurfaceDlgActive)
		return;

	DialogBox(globals.d_hInstance, (char *)IDD_SURFACE, globals.d_hwndMain, SurfaceDlgProc);
}		

BOOL CALLBACK LightDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	char sz[256];
	int blah;
	HWND h;

	switch (uMsg)
    {
	case WM_INITDIALOG:
		sprintf(sz, "%d", globals.d_texturewin.texdef.value);		
		SetWindowText(GetDlgItem(hwndDlg, IDC_L_EDIT), sz);
		h = GetDlgItem(hwndDlg, IDC_L_EDIT);
		SetFocus (h);
		return TRUE;
	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{ 
		
		case IDOK:
			GetWindowText(GetDlgItem(hwndDlg, IDC_L_EDIT), sz, 255);
			Select_MakeLight(atoi(sz), false);
			EndDialog(hwndDlg, 1);
			return TRUE;

		case IDCANCEL:
			EndDialog(hwndDlg, 0);
			return TRUE;
	
		case WM_KEYDOWN:
			GetWindowText(GetDlgItem(hwndDlg, IDC_L_EDIT), sz, 255);
			for(blah = 0; sz[blah] != '\0'; blah++)
			{
				if(sz[blah] < '0' || sz[blah] > '9')
				{
					sz[blah] = '\0';
					SetWindowText(GetDlgItem(hwndDlg, IDC_L_EDIT), sz);
				}
				if(strlen(sz) > 6)
				{
					sz[6] = '\0';
					SetWindowText(GetDlgItem(hwndDlg, IDC_L_EDIT), sz);
				}
			}
			break;
		}
	}
	return FALSE;
}

void DoLight(void)
{
	DialogBox(globals.d_hInstance, (char *)IDD_LIGHT_DIALOG, globals.d_hwndMain, LightDlgProc);
}		

BOOL CALLBACK ClipDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	char sz[256];
	int blah;
	HWND h;

	switch (uMsg)
    {
	case WM_INITDIALOG:
		sprintf(sz, "%d", gcopy.DepthClipDistance);
		SetWindowText(GetDlgItem(hwndDlg, IDC_CLIP_EDIT), sz);
		h = GetDlgItem(hwndDlg, IDC_CLIP_EDIT);
		SendMessage(GetDlgItem(hwndDlg, IDC_CLIPTO2DANDZVIEWS),	BM_SETCHECK, gcopy.Clip2XYZ,		0);
		SendMessage(GetDlgItem(hwndDlg, IDC_USEDEPTHCLIPPING),	BM_SETCHECK, gcopy.DepthClipping,	0);
		SetFocus (h);

		return TRUE;
	case WM_NOTIFY:
		hdr = (NMHDR *)lParam;

		switch (hdr->code)
		{
			case PSN_KILLACTIVE:
			case PSN_APPLY:
				gcopy.Clip2XYZ		= SendMessage(GetDlgItem(hwndDlg, IDC_CLIPTO2DANDZVIEWS),	BM_GETCHECK, 0, 0);
				gcopy.DepthClipping	= SendMessage(GetDlgItem(hwndDlg, IDC_USEDEPTHCLIPPING),	BM_GETCHECK, 0, 0);
				GetWindowText(GetDlgItem(hwndDlg, IDC_CLIP_EDIT), sz, 255);
				blah = atoi(sz);
				gcopy.DepthClipDistance = blah;

				if(gcopy.DepthClipping)
				{
					Sys_Status(0, "Clip Distance: %d", blah);
				}

				Sys_UpdateWindows (W_CAMERA);
				
				if(!globals.DepthClipping)
					Sys_Status(2, "Depth Clip OFF");
				else
					Sys_Status(2, "Clip Distance: %d", globals.DepthClipDistance);

				Sys_UpdateWindows (W_CAMERA);

				return FALSE;
				break;
		}
		break;
	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{
		case WM_KEYDOWN:
			GetWindowText(GetDlgItem(hwndDlg, IDC_CLIP_EDIT), sz, 255);
			for(blah = 0; sz[blah] != '\0'; blah++)
			{
				if(sz[blah] < '0' || sz[blah] > '9')
				{
					sz[blah] = '\0';
					SetWindowText(GetDlgItem(hwndDlg, IDC_CLIP_EDIT), sz);
				}
				if(strlen(sz) > 6)
				{
					sz[6] = '\0';
					SetWindowText(GetDlgItem(hwndDlg, IDC_CLIP_EDIT), sz);
				}
			}
			break;
		}
	}
	return FALSE;
}

BOOL CALLBACK StepHeightDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	char sz[256];
	int blah;
	HWND h;

	switch (uMsg)
    {
	case WM_INITDIALOG:
		sprintf(sz, "%d", gcopy.StepHeight);
		SetWindowText(GetDlgItem(hwndDlg, IDC_STEPHEIGHT_EDIT), sz);
		h = GetDlgItem(hwndDlg, IDC_STEPHEIGHT_EDIT);
		SetFocus (h);
		return TRUE;
	case WM_NOTIFY:
		hdr = (NMHDR *)lParam;

		switch (hdr->code)
		{
			case PSN_KILLACTIVE:
			case PSN_APPLY:
				GetWindowText(GetDlgItem(hwndDlg, IDC_STEPHEIGHT_EDIT), sz, 255);
				blah = atoi(sz);
				gcopy.StepHeight = blah;
				return FALSE;
				break;
		}
		break;
	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{ 
		
		case WM_KEYDOWN:
			GetWindowText(GetDlgItem(hwndDlg, IDC_STEPHEIGHT_EDIT), sz, 255);
			for(blah = 0; sz[blah] != '\0'; blah++)
			{
				if(sz[blah] < '0' || sz[blah] > '9')
				{
					sz[blah] = '\0';
					SetWindowText(GetDlgItem(hwndDlg, IDC_STEPHEIGHT_EDIT), sz);
				}
				if(strlen(sz) > 6)
				{
					sz[6] = '\0';
					SetWindowText(GetDlgItem(hwndDlg, IDC_STEPHEIGHT_EDIT), sz);
				}
			}
			break;
		}
	}
	return FALSE;
}


/*
	Find enitites by key/value dialog
*/
BOOL CALLBACK SelectEntitiesByKeyValDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	char	key[256], value[256];
	HWND	h;

	switch (uMsg)
    {
	case WM_INITDIALOG:
		h = GetDlgItem(hwndDlg, IDC_KEYEDIT);
		SetFocus (h);
		return FALSE;

	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{ 
		
		case IDOK:
			GetWindowText(GetDlgItem(hwndDlg, IDC_KEYEDIT), key, 255);
			GetWindowText(GetDlgItem(hwndDlg, IDC_VALUEEDIT), value, 255);
			Select_EntitiesByKeyVal(key, value);


			EndDialog(hwndDlg, 1);
			return TRUE;

		case IDCANCEL:
			EndDialog(hwndDlg, 0);
			return TRUE;
		}	
	}

	return FALSE;
}

void DoSelectEntitiesByKeyVal(void)
{
	DialogBox(globals.d_hInstance, (char *)IDD_SELECTENTITES, globals.d_hwndMain, SelectEntitiesByKeyValDlgProc);
}



int GetColor(vec3_t color)
{
	CHOOSECOLOR		cc;
	static COLORREF	custom[16];

	cc.lStructSize = sizeof(cc);
	cc.hwndOwner = globals.d_hwndMain;
	cc.hInstance = NULL;
	cc.rgbResult = 
		  (int)(color[0]*255) +
		(((int)(color[1]*255))<<8) +
		(((int)(color[2]*255))<<16);
    cc.lpCustColors = custom;
    cc.Flags = CC_FULLOPEN|CC_RGBINIT; 

	if (!ChooseColor(&cc))
		return false;

	color[0] = ( cc.rgbResult     &255)/255.0;
	color[1] = ((cc.rgbResult>>8 )&255)/255.0;
	color[2] = ((cc.rgbResult>>16)&255)/255.0;

	return true;
}

vec3_t	VisGroupColor;
char	*VisGroupDescription = NULL;
int		VisGroupEditType;

BOOL CALLBACK EditVisGroupDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	int					i;
	HDC					hdc;
	LPDRAWITEMSTRUCT	dis;
	HWND				h;

	switch (uMsg)
    {
		case WM_INITDIALOG:
			h = GetDlgItem(hwndDlg, IDC_NAME_EDIT);

			if(VisGroupEditType == 0) // Creating a new group
				SetWindowText (hwndDlg, "Create New Vis Group");
			else
			{
				SetWindowText (hwndDlg, "Edit Vis Group");
				
				if(VisGroupDescription)
				{
					SetWindowText(h, VisGroupDescription);
					SendMessage(h, EM_SETSEL, 0, -1);
				}
			}
			if(VisGroupEditType == 2)
				EnableWindow(h, FALSE); // Don't let the default group's name change
			else
				EnableWindow(h, TRUE);

			SetFocus(h);

			return TRUE;
		
		case WM_COMMAND:
			switch (LOWORD(wParam)) 
			{
				case IDOK:
				{
					char	desc[1024];

					if(VisGroupEditType != 2)
					{
						if((i = SendMessage(GetDlgItem(hwndDlg, IDC_NAME_EDIT), WM_GETTEXT , (WPARAM)1023, (LPARAM)desc)) != 0)
						{
							desc[i] = 0;
							Sys_Printf("%d, %s\n", i, desc);
							VisGroupDescription = strdup(desc);
							EndDialog(hwndDlg, 1);
						}
						else
							MessageBox(hwndDlg, "You must provide a description", "Error", MB_OK | MB_ICONERROR );
					}
					
					return TRUE;
				}
				
				case IDCANCEL:
					EndDialog(hwndDlg, 0);					
					return TRUE;
				
				case IDC_CHANGECOLOR_BUTTON:
					if(GetColor(VisGroupColor))
					{
						InvalidateRect(GetDlgItem(hwndDlg, IDC_COLOR_STATIC), NULL, false);
					}
					return TRUE;
			}

		case WM_DRAWITEM:
			if(wParam == IDC_COLOR_STATIC)
			{
				HBRUSH	oldbrush, newbrush;

				dis = (LPDRAWITEMSTRUCT)lParam;
				hdc = dis->hDC;

				newbrush = CreateSolidBrush(RGB(VisGroupColor[0]*255, VisGroupColor[1]*255, VisGroupColor[2]*255));

				oldbrush = (HBRUSH)SelectObject(hdc, newbrush);
				FillRect(hdc, &dis->rcItem, newbrush);

                SelectObject(hdc, oldbrush);
				DeleteObject(newbrush);

				return TRUE;
			}

			break;
	}
	return FALSE;
}

int DoCreateVisGroup(void)
{
	if(VisGroupDescription)
	{
		free(VisGroupDescription);
		VisGroupDescription = NULL;
	}

	VisGroupColor[0] = VisGroupColor[1] = VisGroupColor[2] = 0.0f;
	VisGroupEditType = 0;

	if(DialogBox(globals.d_hInstance, (char *)IDD_CREATEVISGROUP_DIALOG, globals.d_hwndMain, EditVisGroupDlgProc))
	{
		int	i = VisGroup_Renumber();
		VisGroup_AddNew(VisGroupDescription, VisGroupColor, i);
		return i;
	}
	return 0;
}		

int DoEditVisGroup(int index)
{
	visgroup_t	*group;

	if(VisGroupDescription)
		free(VisGroupDescription);

	group = GetVisGroup(index);
	VisGroupDescription = strdup(group->name);
	VectorCopy(group->color, VisGroupColor);
	VisGroupEditType = index!=0?1:2;

	if(DialogBox(globals.d_hInstance, (char *)IDD_CREATEVISGROUP_DIALOG, globals.d_hwndMain, EditVisGroupDlgProc))
	{
		if(index != 0)
			VisGroup_SetName(group, VisGroupDescription);

		VectorCopy(VisGroupColor, group->color);
		return true;
	}
	return false;
}		

BOOL CALLBACK SetVisGroupDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	HWND		h;
	visgroup_t	*g;
	int			i;

	switch (uMsg)
    {
		case WM_INITDIALOG:
			VisGroup_Renumber();
			
			h = GetDlgItem(hwndDlg, IDC_GROUPS_LIST);
			VisGroup_FillListBox(h);
			SetFocus (h);
			SendMessage(h, LB_SETCURSEL, currentvisgroup->identifier, 0);
			return TRUE;
		
		case WM_COMMAND:
			switch (LOWORD(wParam)) 
			{
				case IDOK:
					if((i = SendMessage(GetDlgItem(hwndDlg, IDC_GROUPS_LIST), LB_GETCURSEL, 0, 0)) != LB_ERR)
					{
						currentvisgroup = GetVisGroup(i);
						VisGroup_SetSelected();
						EndDialog(hwndDlg, 1);
					}
					else
						MessageBox(hwndDlg, "You must select a group", "Error", MB_OK | MB_ICONERROR );
					
					return TRUE;
				
				case IDCANCEL:
					EndDialog(hwndDlg, 0);					
					return TRUE;
				
				case IDC_CREATE_BUTTON:
				{
					i = DoCreateVisGroup();
					VisGroup_FillListBox(GetDlgItem(hwndDlg, IDC_GROUPS_LIST));
					if(i)
					{
						SendMessage(GetDlgItem(hwndDlg, IDC_GROUPS_LIST), LB_SETCURSEL, i, 0);
					}

					return TRUE;
				}

				case IDC_EDIT_BUTTON:
					h = GetDlgItem(hwndDlg, IDC_GROUPS_LIST);
					if((i = SendMessage(h, LB_GETCURSEL, 0, 0)) != LB_ERR)
					{
						DoEditVisGroup(i);
						VisGroup_FillListBox(h);
						SendMessage(h, LB_SETCURSEL, i, 0);
					}
					else
						MessageBox(hwndDlg, "You must select a group before you can edit it", "Error", MB_OK | MB_ICONERROR );

					return TRUE;

				case IDC_DELETE_BUTTON:
					h = GetDlgItem(hwndDlg, IDC_GROUPS_LIST);
					if((i = SendMessage(h, LB_GETCURSEL, 0, 0)) != LB_ERR)
					{
						if(!i)
						{
							MessageBox(hwndDlg, "Cannot delete the default group!", "Error", MB_OK | MB_ICONERROR );
							return TRUE;
						}
						g = GetVisGroup(i);
						ReplaceVisGroup(g, GetVisGroup(0));

						if(currentvisgroup == g)
							currentvisgroup = GetVisGroup(0);

						VisGroup_Free(g);
						VisGroup_FillListBox(h);
					}
					else
						MessageBox(hwndDlg, "You must select a group before you can delete it", "Error", MB_OK | MB_ICONERROR );

					return TRUE;
			}
	}
	return FALSE;
}

void DoSetVisGroup(void)
{
	DialogBox(globals.d_hInstance, (char *)IDD_SETVISGROUP_DIALOG, globals.d_hwndMain, SetVisGroupDlgProc);
}		

BOOL CALLBACK FitTexturesDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	HWND			h;
	char	sz[128];

	switch (uMsg)
    {
	case WM_INITDIALOG:
		g_surfwin = hwndDlg;
		h = GetDlgItem(hwndDlg, IDC_WIDTH_EDIT);
		SetFocus (h);
		sprintf(sz, "%d", (int)m_nWidth);
		SetWindowText(GetDlgItem(hwndDlg, IDC_WIDTH_EDIT), sz);
		sprintf(sz, "%d", (int)m_nHeight);
		SetWindowText(GetDlgItem(hwndDlg, IDC_HEIGHT_EDIT), sz);
		return FALSE;

	case WM_COMMAND: 
		switch (LOWORD(wParam))
		{
			case IDOK:
			{
				GetWindowText (GetDlgItem(hwndDlg, IDC_WIDTH_EDIT), sz, 127);
				m_nWidth = atoi(sz);
				GetWindowText (GetDlgItem(hwndDlg, IDC_HEIGHT_EDIT), sz, 127);
				m_nHeight = atoi(sz);
				Select_FitTexture(m_nHeight, m_nWidth);
				InvalidateRect(globals.Camera.hwnd, NULL, false);
				UpdateWindow (globals.Camera.hwnd);
				if(globals.d_xy.draw_mode == cd_texture)
				{
					InvalidateRect(globals.XY.hwnd, NULL, false);
					UpdateWindow (globals.XY.hwnd);
					InvalidateRect(globals.XZ.hwnd, NULL, false);
					UpdateWindow (globals.XZ.hwnd);
					InvalidateRect(globals.YZ.hwnd, NULL, false);
					UpdateWindow (globals.YZ.hwnd);
				}
				EndDialog(hwndDlg, 1);
				break;
			}
			
			case IDCANCEL:
				EndDialog(hwndDlg, 0);
				break;
		}	
		break;

	case WM_DESTROY:
		SurfaceDlgActive = false;
		break;


	}
	return FALSE;
}



int DoFitTextures (void)
{
	return (DialogBox(globals.d_hInstance, (char *)IDD_FITTEXTURE_DIALOG, globals.d_hwndMain, FitTexturesDlgProc));
}		

char *color_names[] = { "Texture Window Background Color",
						"XY And Background Color",
						"Grid Minor Line Color",
						"Grid Major Line Color",
						"Camera Background Color",
						"COLOR_ENTITY",
						"Texture Window Text Color",
						"Grid Text Color",
						"Worldspawn Line Color",
						"Camera Icon Color",
						"Z Icon Color",
						"Selection Color",
						"Selection Outline Color",
						"Q3A Shader Outline Color",
						"RScript Outline Color"
};

int ColorComboCursel;
vec3_t colors[COLOR_LAST];


BOOL CALLBACK ColorSettingsDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	int					i;
	HDC					hdc;
	LPDRAWITEMSTRUCT	dis;
	HWND				h;

	switch (uMsg)
    {
		case WM_INITDIALOG:
			h = GetDlgItem(hwndDlg, IDC_COLORLIST_COMBO);
			SendMessage(h, CB_RESETCONTENT, 0 , 0);

			for(i = 0; i < COLOR_LAST; i++)
			{
				SendMessage(h, CB_ADDSTRING, 0, (LPARAM)color_names[i]);
			}
			
			SendMessage(h, CB_SETCURSEL, (WPARAM)0, 0);
			ColorComboCursel = 0;
			SetFocus(h);

			return TRUE;
		
		case WM_COMMAND:
			switch (LOWORD(wParam)) 
			{
				case IDC_CHANGECOLOR_BUTTON:
				{
					vec3_t	color;

					VectorCopy(colors[ColorComboCursel], color);
					if(GetColor(color))
					{
						VectorCopy(color, gcopy.d_savedinfo.colors[ColorComboCursel]);
						InvalidateRect(GetDlgItem(hwndDlg, IDC_COLOR_STATIC), NULL, false);

					}
					return TRUE;
				}

				case IDC_COLORLIST_COMBO:
				{
					switch(HIWORD(wParam))
					{
						case CBN_SELCHANGE:
						{
							ColorComboCursel = SendMessage((HWND)lParam, CB_GETCURSEL, 0, 0);
							InvalidateRect(GetDlgItem(hwndDlg, IDC_COLOR_STATIC), NULL, false);
						}
						break;
					}
				}
			}

		case WM_DRAWITEM:
			if(wParam == IDC_COLOR_STATIC)
			{
				vec3_t color;
				HBRUSH	oldbrush, newbrush;

				VectorCopy(gcopy.d_savedinfo.colors[ColorComboCursel], color);
				dis = (LPDRAWITEMSTRUCT)lParam;
				hdc = dis->hDC;

				newbrush = CreateSolidBrush(RGB(color[0]*255, color[1]*255, color[2]*255));

				oldbrush = (HBRUSH)SelectObject(hdc, newbrush);
				FillRect(hdc, &dis->rcItem, newbrush);

                SelectObject(hdc, oldbrush);
				DeleteObject(newbrush);

				return TRUE;
			}

			break;
	}
	return FALSE;
}

char *desc[] = {
	"BST_UNCHECKED",
	"BST_CHECKED",
	"BST_INDETERMINATE"
};
void InitCheckboxes(HWND hwnd)
{
	int			i, mask, count[64];
	face_t		*f;
	brush_t		*b;
	facesel_t	*face;

	for(i = 0; i < 32; i++)
	{
		g_checkboxes[i] = g_checkboxes[i+32] = count[i] = count[i+32] = 0;
		mask = 1 << i;

		for(b = selected_brushes.next; b != &selected_brushes; b = b->next)
		{
			for(f = b->brush_faces; f; f = f->next, count[i]++, count[i+32]++)
			{
				g_checkboxes[i] += (f->texdef.flags&mask?1:0);
				g_checkboxes[i+32] += (f->texdef.contents&mask?1:0);
			}
		}
		for(face = selected_faces; face; face = face->next, count[i]++, count[i+32]++)
		{
				g_checkboxes[i] += (face->face->texdef.flags&mask?1:0);
				g_checkboxes[i+32] += (face->face->texdef.contents&mask?1:0);
		}
		SetWindowText(GetDlgItem(hwnd, IDC_CHECK1+i), Surface_FlagNames[i]);
		SetWindowText(GetDlgItem(hwnd, IDC_CHECK33+i), Content_FlagNames[i]);
	}
	for(i = 0; i < 64; i++)
	{
		if(g_checkboxes[i])
		{
			if(g_checkboxes[i] != count[i])
				g_checkboxes[i] = BST_INDETERMINATE;
			else
				g_checkboxes[i] = BST_CHECKED;
		}
		else
			g_checkboxes[i] = BST_UNCHECKED;

		SendMessage(GetDlgItem(hwnd, i+IDC_CHECK1), BM_SETSTYLE, g_checkboxes[i] == BST_INDETERMINATE?BS_AUTO3STATE:BS_AUTOCHECKBOX, TRUE);
		SendMessage(GetDlgItem(hwnd, i+IDC_CHECK1), BM_SETCHECK, g_checkboxes[i], 0 );
		
	}
}

void ApplyFlagChanges(HWND hwnd)
{
	int i, state, fsetmask, funsetmask, csetmask, cunsetmask, fset, funset, cset, cunset;

	fsetmask = funsetmask = csetmask = cunsetmask = fset = funset = cset = cunset = 0;

	for(i = 0; i < 32; i++)
	{
		state = SendMessage(GetDlgItem(hwnd, i+IDC_CHECK1), BM_GETSTATE, 0, 0) & 3;

		if(state != g_checkboxes[i])
		{
			if(state)
			{
				fsetmask |= 1<<i;
				fset = 1;
			}
			else
			{
				funsetmask |= 1<<i;
				funset = 1;
			}
		}

		state = SendMessage(GetDlgItem(hwnd, i+IDC_CHECK33), BM_GETSTATE, 0, 0) & 3;

		if(state != g_checkboxes[i+32])
		{
			if(state)
			{
				csetmask |= 1<<i;
				cset = 1;
			}
			else
			{
				cunsetmask |= 1<<i;
				cunset = 1;
			}
		}
	}
	
	if(fset)
		Select_SetSurfaceFlag (fsetmask);
	if(funset)
		Select_UnsetSurfaceFlag (funsetmask);
	if(cset)
		Select_SetContentsFlag(csetmask);
	if(cunset)
		Select_UnsetContentsFlag(cunsetmask);
}

BOOL CALLBACK ChangeFlagsDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	switch (uMsg)
    {
		case WM_INITDIALOG:
			InitCheckboxes(hwndDlg);
			InvalidateRect (g_surfwin, NULL, true);
			UpdateWindow(g_surfwin);
			return FALSE;
			break;
		
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDOK:
					ApplyFlagChanges(hwndDlg);
					EndDialog(hwndDlg, 1);
					break;
				
				case IDCANCEL:
					EndDialog(hwndDlg, 0);
					break;
			}
			break;
			
			case WM_KEYDOWN:
				if (LOWORD(wParam) == VK_ESCAPE)
				{
					EndDialog(hwndDlg, 0);
				}
				break;
			
	}
	return FALSE;
}

void DoChangeFlags (void)
{
	DialogBox(globals.d_hInstance, (char *)IDD_CHANGEFLAGS_DIALOG, globals.d_hwndMain, ChangeFlagsDlgProc);
}		


BOOL CALLBACK PrefViewsDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	switch (uMsg)
    {
		case WM_INITDIALOG:
			SendMessage(GetDlgItem(hwndDlg, IDC_MULTIPLE2DVIEWS),				BM_SETCHECK, gcopy.Multiple2DViews,		0);
			SendMessage(GetDlgItem(hwndDlg, IDC_LOCKZAND2DVIEWSTOCAMERAVIEW),	BM_SETCHECK, gcopy.LockXYZ2Cam,			0);
			SendMessage(GetDlgItem(hwndDlg, IDC_LOCK2DVIEWSTOEACHOTHER),		BM_SETCHECK, gcopy.Lock2DOrigins,		0);
			SendMessage(GetDlgItem(hwndDlg, IDC_LOCK2DVIEWSZOMMTOEACHOTHER),	BM_SETCHECK, gcopy.Lock2DZoom,			0);
			SendMessage(GetDlgItem(hwndDlg, IDC_LOCKCAMERAORIGINTO2DVIEWS),		BM_SETCHECK, gcopy.LockCamTo2DOrigins,	0);
			SendMessage(GetDlgItem(hwndDlg, IDC_OLDCAMERAMOVEMENT),				BM_SETCHECK, gcopy.OldCameraMovement,	0);

			return FALSE;
			break;		

	case WM_NOTIFY:
		hdr = (NMHDR *)lParam;

		switch (hdr->code)
		{
			case PSN_KILLACTIVE:
			case PSN_APPLY:
				gcopy.Multiple2DViews		= SendMessage(GetDlgItem(hwndDlg, IDC_MULTIPLE2DVIEWS),				BM_GETCHECK, 0, 0);
				gcopy.LockXYZ2Cam			= SendMessage(GetDlgItem(hwndDlg, IDC_LOCKZAND2DVIEWSTOCAMERAVIEW),	BM_GETCHECK, 0, 0);
				gcopy.Lock2DOrigins			= SendMessage(GetDlgItem(hwndDlg, IDC_LOCK2DVIEWSTOEACHOTHER),		BM_GETCHECK, 0, 0);
				gcopy.Lock2DZoom			= SendMessage(GetDlgItem(hwndDlg, IDC_LOCK2DVIEWSZOMMTOEACHOTHER),	BM_GETCHECK, 0, 0);
				gcopy.LockCamTo2DOrigins	= SendMessage(GetDlgItem(hwndDlg, IDC_LOCKCAMERAORIGINTO2DVIEWS),	BM_GETCHECK, 0, 0);
				gcopy.OldCameraMovement		= SendMessage(GetDlgItem(hwndDlg, IDC_OLDCAMERAMOVEMENT),			BM_GETCHECK, 0, 0);
				return FALSE;
				break;
		}
		break;
	}
	return FALSE;
}

BOOL CALLBACK AnimationDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	char		sz[256];
	int			speed;
	static int	savedspeed;

	switch (uMsg)
    {
	case WM_INITDIALOG:
		if(!gcopy.AnimationSpeed)
			gcopy.AnimationSpeed = 1;

		savedspeed = 1.0f / (float)gcopy.AnimationSpeed / 0.001f;
		sprintf(sz, "%d", savedspeed);
		SetWindowText(GetDlgItem(hwndDlg, IDC_ANIMATIONSPEED), sz);
		SendMessage(GetDlgItem(hwndDlg, IDC_ANIMATECAMERA),		BM_SETCHECK, gcopy.AnimateCameraRScripts,	0);
		SendMessage(GetDlgItem(hwndDlg, IDC_ANIMATETEXTURE),	BM_SETCHECK, gcopy.AnimateTextureRScripts,	0);
		SendMessage(GetDlgItem(hwndDlg, IDC_ANIMATESKY),		BM_SETCHECK, gcopy.AnimateSky,				0);
		return TRUE;
	case WM_NOTIFY:
		hdr = (NMHDR *)lParam;

		switch (hdr->code)
		{
			case PSN_KILLACTIVE:
			case PSN_APPLY:
				GetWindowText(GetDlgItem(hwndDlg, IDC_ANIMATIONSPEED), sz, 255);
				speed = atoi(sz);

				if(speed != savedspeed)
				{
					if(!speed || speed > 1000)
					{
						MessageBox(globals.d_hwndMain, "Animation speed must be an integer from 1 to 1000",NULL, MB_OK);
						SetFocus(GetDlgItem(hwndDlg, IDC_ANIMATIONSPEED));
						return TRUE;
					}
					gcopy.AnimationSpeed = 1000 / speed;
				}
				gcopy.AnimateCameraRScripts		= SendMessage(GetDlgItem(hwndDlg, IDC_ANIMATECAMERA),	BM_GETCHECK, 0, 0);
				gcopy.AnimateTextureRScripts	= SendMessage(GetDlgItem(hwndDlg, IDC_ANIMATETEXTURE),	BM_GETCHECK, 0, 0);
				gcopy.AnimateSky				= SendMessage(GetDlgItem(hwndDlg, IDC_ANIMATESKY),		BM_GETCHECK, 0, 0);
				return FALSE;
				break;
		}
		break;
	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{ 
		
		case WM_KEYDOWN:
			{
				int	i;
				
				GetWindowText(GetDlgItem(hwndDlg, IDC_ANIMATIONSPEED), sz, 255);
				for(i = 0; sz[i] != '\0'; i++)
				{
					if(sz[i] < '0' || sz[i] > '9')
					{
						sz[i] = '\0';
						SetWindowText(GetDlgItem(hwndDlg, IDC_ANIMATIONSPEED), sz);
					}
					if(strlen(sz) > 6)
					{
						sz[6] = '\0';
						SetWindowText(GetDlgItem(hwndDlg, IDC_ANIMATIONSPEED), sz);
					}
				}
			}
			break;
		}
	}
	return FALSE;
}

BOOL CALLBACK GridSettingsDlgProc (
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	char sz[256];
	int blah;
	HWND h;

	switch (uMsg)
    {
	case WM_INITDIALOG:
		sprintf(sz, "%d", gcopy.MaxGridExtent);
		SetWindowText(GetDlgItem(hwndDlg, IDC_GRIDEXTENT_EDIT), sz);
		h = GetDlgItem(hwndDlg, IDC_GRIDEXTENT_EDIT);
		SetFocus (h);
		return TRUE;
	case WM_NOTIFY:
		hdr = (NMHDR *)lParam;

		switch (hdr->code)
		{
			case PSN_KILLACTIVE:
			case PSN_APPLY:
				GetWindowText(GetDlgItem(hwndDlg, IDC_GRIDEXTENT_EDIT), sz, 255);
				blah = atoi(sz);
				gcopy.MaxGridExtent = abs(blah);
				return FALSE;
				break;
		}
		break;
	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{ 
		
		case WM_KEYDOWN:
			GetWindowText(GetDlgItem(hwndDlg, IDC_GRIDEXTENT_EDIT), sz, 255);
			for(blah = 0; sz[blah] != '\0'; blah++)
			{
				if(sz[blah] < '0' || sz[blah] > '9')
				{
					sz[blah] = '\0';
					SetWindowText(GetDlgItem(hwndDlg, IDC_GRIDEXTENT_EDIT), sz);
				}
				if(strlen(sz) > 6)
				{
					sz[6] = '\0';
					SetWindowText(GetDlgItem(hwndDlg, IDC_GRIDEXTENT_EDIT), sz);
				}
			}
			break;
		}
	}
	return FALSE;
}

int CALLBACK RemoveContextHelpProc(HWND hwnd, UINT message, LPARAM lParam)
{
    switch (message)
	{
		case PSCB_PRECREATE:
			// Remove the DS_CONTEXTHELP style from the
			// dialog box template
//			if (((LPDLGTEMPLATEEX)lParam)->signature == 0xFFFF)
//			{
//				((LPDLGTEMPLATEEX)lParam)->style &= ~DS_CONTEXTHELP;
//			}
//			else
			{
				((LPDLGTEMPLATE)lParam)->style &= ~DS_CONTEXTHELP;
			}
			return TRUE;
    }
    return TRUE;
}

void DoPreferences(void)
{
    PROPSHEETPAGE	psp[7];
    PROPSHEETHEADER	psh;
	int				retval;

    psp[0].dwSize = sizeof(PROPSHEETPAGE);
    psp[0].dwFlags = PSP_USEICONID | PSP_USETITLE;
    psp[0].hInstance = globals.d_hInstance;
    psp[0].pszTemplate = MAKEINTRESOURCE(IDD_PREFERENCES_VIEWS_DIALOG);
    psp[0].pszIcon = NULL;
    psp[0].pfnDlgProc = PrefViewsDlgProc;
    psp[0].pszTitle = "Views";
    psp[0].lParam = 0;
    psp[0].pfnCallback = NULL;

    psp[1].dwSize = sizeof(PROPSHEETPAGE);
    psp[1].dwFlags = PSP_USEICONID | PSP_USETITLE;
    psp[1].hInstance = globals.d_hInstance;
    psp[1].pszTemplate = MAKEINTRESOURCE(IDD_COLORSETTINGS);
    psp[1].pszIcon = NULL;
    psp[1].pfnDlgProc = ColorSettingsDlgProc;
    psp[1].pszTitle = "Colors";
    psp[1].lParam = 0;
    psp[1].pfnCallback = NULL;

    psp[2].dwSize = sizeof(PROPSHEETPAGE);
    psp[2].dwFlags = PSP_USEICONID | PSP_USETITLE;
    psp[2].hInstance = globals.d_hInstance;
    psp[2].pszTemplate = MAKEINTRESOURCE(IDD_GAMMA);
    psp[2].pszIcon = NULL;
    psp[2].pfnDlgProc = GammaDlgProc;
    psp[2].pszTitle = "Gamma";
    psp[2].lParam = 0;
    psp[2].pfnCallback = NULL;

    psp[3].dwSize = sizeof(PROPSHEETPAGE);
    psp[3].dwFlags = PSP_USEICONID | PSP_USETITLE;
    psp[3].hInstance = globals.d_hInstance;
    psp[3].pszTemplate = MAKEINTRESOURCE(IDD_CLIP_DIALOG);
    psp[3].pszIcon = NULL;
    psp[3].pfnDlgProc = ClipDlgProc;
    psp[3].pszTitle = "Clipping";
    psp[3].lParam = 0;
    psp[3].pfnCallback = NULL;

    psp[4].dwSize = sizeof(PROPSHEETPAGE);
    psp[4].dwFlags = PSP_USEICONID | PSP_USETITLE;
    psp[4].hInstance = globals.d_hInstance;
    psp[4].pszTemplate = MAKEINTRESOURCE(IDD_STEPHEIGHT_DIALOG);
    psp[4].pszIcon = NULL;
    psp[4].pfnDlgProc = StepHeightDlgProc;
    psp[4].pszTitle = "Step Height";
    psp[4].lParam = 0;
    psp[4].pfnCallback = NULL;

    psp[5].dwSize = sizeof(PROPSHEETPAGE);
    psp[5].dwFlags = PSP_USEICONID | PSP_USETITLE;
    psp[5].hInstance = globals.d_hInstance;
    psp[5].pszTemplate = MAKEINTRESOURCE(IDD_ANIMATION_DIALOG);
    psp[5].pszIcon = NULL;
    psp[5].pfnDlgProc = AnimationDlgProc;
    psp[5].pszTitle = "Animation";
    psp[5].lParam = 0;
    psp[5].pfnCallback = NULL;

    psp[6].dwSize = sizeof(PROPSHEETPAGE);
    psp[6].dwFlags = PSP_USEICONID | PSP_USETITLE;
    psp[6].hInstance = globals.d_hInstance;
    psp[6].pszTemplate = MAKEINTRESOURCE(IDD_GRIDSETTINGS_DIALOG);
    psp[6].pszIcon = NULL;
    psp[6].pfnDlgProc = GridSettingsDlgProc;
    psp[6].pszTitle = "Grid Settings";
    psp[6].lParam = 0;
    psp[6].pfnCallback = NULL;

    psh.dwSize = sizeof(PROPSHEETHEADER);
    psh.dwFlags = PSH_USEICONID | PSH_PROPSHEETPAGE;
    psh.hwndParent = globals.d_hwndMain;
    psh.hInstance = globals.d_hInstance;
    psh.pszIcon = NULL;
    psh.pszCaption = (LPSTR) "Settings";
    psh.nPages = sizeof(psp) / sizeof(PROPSHEETPAGE);
    psh.nStartPage = 0;
    psh.ppsp = (LPCPROPSHEETPAGE) &psp;
    psh.pfnCallback = RemoveContextHelpProc;

	memcpy(&gcopy, &globals, sizeof(gcopy));
    retval = PropertySheet(&psh);

	if(retval)
	{
		int		Multiple2DViews;	//QE5 doesn't like when you memcpy gcopy to globals AFTER changing 2d view count.
		int		GridSizeChanged = 0;

		if(gcopy.AnimationSpeed != globals.AnimationSpeed)
		{
			if(gcopy.AnimateCameraRScripts || gcopy.AnimateTextureRScripts || gcopy.AnimateSky)
				SetTimer(globals.d_hwndMain, QE_TIMER1, gcopy.AnimationSpeed, NULL);
			else// if(globals.AnimateCameraRScripts || globals.AnimateTextureRScripts || globals.AnimateSky)
				KillTimer(globals.d_hwndMain, QE_TIMER1 );
		}

		if(!region_active && globals.MaxGridExtent != gcopy.MaxGridExtent)
			GridSizeChanged = 1;

		Multiple2DViews = gcopy.Multiple2DViews;
		memcpy(&globals, &gcopy, sizeof(gcopy));

		if(Multiple2DViews != globals.Multiple2DViews)
		{
			globals.Multiple2DViews ^= 1;

			if(globals.Multiple2DViews)
				DestroyExtra2DViews();
			else
				CreateExtra2DViews();

			globals.Multiple2DViews ^= 1;
		}
		if(GridSizeChanged)
			Map_RegionOff();
	}
    return;
}


int		CreateEntityPointBased;
int		CreateEntityBrushBased;
int		CreateEntityFromSelection;

int MakeEntity(HWND h)
{
	int			index;
	eclass_t	*pec;
	char *text = "You have chosen to create a point-based entity\nwith more than one brush selected. This operation\nwill create one entity centered on the midpoint of\nall selected brushes and the selected brushes will\nbe deleted. Are you sure you want to do this?";
	
	index = SendMessage(h, LB_GETCURSEL, 0, 0);
	pec = (eclass_t *)SendMessage(h, LB_GETITEMDATA, index, 0);
	if(pec->fixedsize && selected_brushes.next != &selected_brushes && selected_brushes.next->next != &selected_brushes)
	{

		if(MessageBox(globals.d_hwndMain, text, "Confirm Entity Creation", MB_OKCANCEL|MB_ICONQUESTION /* MB_OK */ ) != IDOK)
			return false;
	}
	VectorAdd(selected_brushes.mins, pec->mins, selected_brushes.mins);
	Entity_Create(pec);

	return true;
}

BOOL CALLBACK CreateEntityDlgProc (
    HWND hwndDlg,
    UINT uMsg,
    WPARAM wParam,
    LPARAM lParam
   )
{
	static HWND	h;
	switch (uMsg)
    {
	case WM_INITDIALOG:
		h = GetDlgItem(hwndDlg, IDC_ENTITYLIST);
		FillEntityListbox(h, CreateEntityPointBased, CreateEntityBrushBased);
		SetFocus (h);
		return FALSE;

	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{
			case IDOK:
				if(MakeEntity(h))
					EndDialog(hwndDlg, 1);
				else
					SetFocus(hwndDlg);
				return TRUE;
			
			case IDCANCEL:
				EndDialog(hwndDlg, 0);
				return TRUE;
			
			case IDC_ENTITYLIST:
				switch (HIWORD(wParam))
				{
					case LBN_DBLCLK:
						if(MakeEntity(h))
							EndDialog(hwndDlg, 1);
						else
							SetFocus(hwndDlg);

						break;
				}
				break;
		}	
	}

	return FALSE;
}

void DoCreateEntity(int pointbased, int brushbased, int sel, vec3_t origin)
{
	CreateEntityPointBased = pointbased;
	CreateEntityBrushBased = brushbased;
	CreateEntityFromSelection = sel;
	if(!sel)
		VectorCopy(origin, selected_brushes.mins);

	DialogBox(globals.d_hInstance, (char *)IDD_ENTITY_DIALOG, globals.d_hwndMain, CreateEntityDlgProc);
}
